/**
 * \file Memory.h
 * \date 30.04.2003
 *
 * Interface for the MemoryInterface class
 */

#ifndef PLAYER_INTERFACES_MEMORY_H
#define PLAYER_INTERFACES_MEMORY_H

#include "Common/Interfaces/Interface.h"
#include "Player/World/World.h"

/**
 * \class MemoryInterface
 * \author Matus Horvath
 * \brief Player/goalie memory interface
 * 
 * Memory task stores information about the environment
 * of the player. This is the new very simple interface
 * incompatible with the old MemoryInterface and 
 * CoachMemoryInterface.
 */
class MemoryInterface : public Interface
{
public:
	// Construction and destruction
	MemoryInterface() : Interface("Memory Interface", "030430") {}
	virtual ~MemoryInterface() {}

	virtual World* GetWorld() const = 0;

};

#endif // PLAYER_INTERFACES_MEMORY_H
